unit pCommon;
interface

{**** begin implementation dependent definitions ****}

{ TP compiler options:
  Force far calls - Disable;
  Stack           - 32K
  Low heap        - 32K
  High heap       - 650K }

type

  real = single;
  { assert( size(real) = 2*size(integer) ) }
  { assert( size(integer) = 2*size(char) ) }
  { assert( size(class) = size(integer) ) }
  { assert( size(stringpointer) = 2*size(integer) ) }
  { x86 alternative: integer = longint; real = double }

const

  { data limits }

  minint = -32768; maxint = 32767; 
  minreal = 1.5e-45; maxreal = 3.4e38;
  intbytes = 2; {size of integers in bytes}
  
  { software limits }

  maxaddr = 10000; maxblock = 200;
  { originally maxaddr was 100000 }
  maxbuf = 10000; maxcase = 128;
  maxchan = 1000;
  { originally maxchan was 10000 }
  maxlabel = 1000; maxlevel = 10;
  maxphrase = 30; maxstring = 81;
  maxident = 16;  maximps = 32;
  maxfields = 10; {dynamic fields}
  maxstruct = 80; {exported structures}
  maxnest = 6; {import nesting level}


{**** end implementation dependent definitions ****}

const

  { compilation options }

  testoptions = false;
  restricted = true;
  arl = 5; {activation record length}
  mainlevel = 1; {level of expored entities}

const
  { standard identifiers }

  minstandard = 1;
  maxstandard = 35;
  abs0 = 1; arctan0 = 2;
  boolean0 = 3; char0 = 4;
  chr0 = 5; cos0 = 6;
  eof0 = 7; eoln0 = 8;
  exp0 = 9; false0 = 10;
  integer0 = 11; ln0 = 12;
  maxint0 = 13; maxstring0 = 14;
  null0 = 15; odd0 = 16;
  open0 = 17; ord0 = 18;
  pred0 = 19; read0 = 20;
  readln0 = 21; real0 = 22;
  receive0 = 23; round0 = 24;
  send0 = 25; sin0 = 26;
  sqr0 = 27; sqrt0 = 28;
  string0 = 29; succ0 = 30;
  true0 = 31; trunc0 = 32;
  write0 = 33; writeln0 = 34;

  { additional standard identifiers }

  random0 = 35;

  { tokens }

  mintoken = 0; maxtoken = 61;
  and1 = 0; array1 = 1;
  assume1 = 2; asterisk1 = 3;
  bar1 = 4; becomes1 = 5;
  begin1 = 6; case1 = 7;
  charconst1 = 8; colon1 = 9;
  comma1 = 10; const1 = 11;
  div1 = 12; do1 = 13;
  downto1 = 14; doubledot1 = 15;
  else1 = 16; end1 = 17;
  endtext1 = 18; equal1 = 19;
  for1 = 20; forall1 = 21;
  function1 = 22; greater1 = 23;
  identifier1 = 24; if1 = 25;
  intconst1 = 26;
  leftbracket1 = 27;
  leftparenthesis1 = 28;
  less1 = 29; minus1 = 30;
  mod1 = 31; newline1 = 32;
  not1 = 33; notequal1 = 34;
  notgreater1 = 35; notless1 = 36;
  of1 = 37; or1 = 38;
  parallel1 = 39; period1 = 40;
  plus1 = 41; procedure1 = 42;
  realconst1 = 43; repeat1 = 44;
  rightbracket1 = 45;
  rightparenthesis1 = 46;
  semicolon1 = 47; sic1 = 48;
  slash1 = 49; stringconst1 = 50;
  then1 = 51; to1 = 52;
  type1 = 53; until1 = 54;
  var1 = 55; while1 = 56;

  { additional tokens }

  class1 = 57;
  import1 = 58;
  nullclass1 = doubledot1;
  module1 = 59;
  inherit1 = 60;
  export1 = asterisk1;
  unrestricted1 = minus1;

  unknown1 = 61;

  { operation parts }

  minoperation = 1; maxoperation = 134;

  {run-timeoperations}
  abs2 = 1;         absint2 = 2;       add2 = 3;
  addreal2 = 4;     and2 = 5;          arctan2 = 6;
  assign2 = 7;      assume2 = 8;       case2 = 9;
  checkio2 = 10;    chr2 = 11;         cos2 = 12;
  divide2 = 13;     divreal2 = 14;     do2 = 15;
  downto2 = 16;     endall2 = 17;      enddown2 = 18;
  endio2 = 19;      endparallel2 = 20; endmethod2 = 21;
  endprocess2 = 22; endto2 = 23;       eof2 = 24;
  eoln2 = 25;       eqord2 = 26;       eqreal2 = 27;
  eqstring2 = 28;   equal2 = 29;       exp2 = 30;
  field2 = 31;      float2 = 32;       floatleft2 = 33;
  for2 = 34;        forall2 = 35;      goto2 = 36;
  grord2 = 37;      grreal2 = 38;      grstring2 = 39;
  index2 = 40;      ln2 = 41;          lsord2 = 42;
  lsreal2 = 43;     lsstring2 = 44;    minus2 = 45;
  minusreal2 = 46;  modulo2 = 47;      multiply2 = 48;
  multreal2 = 49;   neord2 = 50;       nereal2 = 51;
  nestring2 = 52;   ngord2 = 53;       ngreal2 = 54;
  ngstring2 = 55;   nlord2 = 56;       nlreal2 = 57;
  nlstring2 = 58;   not2 = 59;         notequal2 = 60;
  odd2 = 61;        open2 = 62;        or2 = 63;
  ordconst2 = 64;   parallel2 = 65;    pred2 = 66;
  mcall2 = 67;      method2 = 68;      process2 = 69;
  read2 = 70;       readint2 = 71;     readln2 = 72;
  readreal2 = 73;   realconst2 = 74;   receive2 = 75;
  result2 = 76;     round2 = 77;       send2 = 78;
  sin2 = 79;        sqr2 = 80;         sqrint2 = 81;
  sqrt2 = 82;       stringconst2 = 83; subreal2 = 84;
  subtract2 = 85;   succ2 = 86;        to2 = 87;
  trunc2 = 88;      value2 = 89;       variable2 = 90;
  varparam2 = 91;   write2 = 92;       writebool2 = 93;
  writeint2 = 94;   writeln2 = 95;     writereal2 = 96;
  writestring2 = 97;globalcall2 = 98;  globalvalue2 = 99;
  globalvar2 = 100; localreal2 = 101;  localvalue2 = 102;
  localvar2 = 103;  ordassign2 = 104;  ordvalue2 = 105;
  realassign2 = 106;realvalue2 = 107;

  {assembler operations}
  defaddr2 = 108;   defarg2 = 109;

  {loader operations / new}
  modulehead2 = 110;    {start module code}
  loadshared2 = 111; {load a shared (mported) obejct}
  loadprivate2 = 112;{load a private (base) module}

  {initializztion operations / new}

  moduleinit2 = 113;    {start init section}
  endinit2 = 114;    {end init section}

  {installation and ovveriding of
  methods and dynamic types / new}

  installm2  = 115;    {install method}
  iclass2    = 116;    {install class}
  ixclass2   = 117;    {install xclass}
  oxclass2   = 118;    {override xclass}
  ifield2    = 119;    {install field}
  iarray2    = 120;    {install array}

  {run-time operations / new}
  len2        = 121; {compute total length of dynamic type}
  dealloc2    = 122; {deallocate dynamic variale}
  deref2      = 123; {dereference class pointer}
  endmodule2     = 124; {end module execution}
  alloc2      = 125; {allocate dynamic variable}
  moduleenter2   = 126; {start post-init section}
  random2     = 127; {generate a random number}
  xvariable2  = 128; {address of global variable}
  xmcall2  = 129;    {call exported method}
  dvalue2     = 130; {load dynamic value}
  dassign2    = 131; {load dynamic value}
  dresult2    = 132; {allocate dynamic function value}
  imcall2     = 133; {call inherited method, no din binding}
  valueparam2 = 134; {address of value parameter}
  function2 = valueparam2; {return function value}

  { compile-time errors }

  ambiguous3 =
    'ambiguous identifier          ';
  body3 =
    'function body error           ';
  case3 =
    'ambiguous case constant       ';
  comment3 =
    'incomplete comment            ';
  forall3 =
    'forall statement error        ';
  import3 =
    'import error                  ';
  kind3 =
    'identifier kind error         ';
  number3 =
    'number error                  ';
  parallel3 =
    'parallel statement error      ';
  parameter3 =
    'function parameter error      ';
  procedure3 =
    'procedure statement error     ';
  range3 =
    'index range error             ';
  recursion3 =
    'recursion error               ';
  syntax3 =
    'syntax error                  ';
  type3 =
    'type error                    ';
  undefined3 =
    'undefined identifier          ';
  restricted3 =
    'restricted method error       ';

  { run-time errors }

  assume4 =
    'false assumption              ';
  case4 =
    'undefined case constant       ';
  channel4 =
    'undefined channel reference   ';
  contention4 =
    'channel contention            ';
  deadlock4 =
    'deadlock                      ';
  range4 =
    'range error                   ';
  type4 =
    'message type error            ';

  { software limits }

  implementation5 =
    'implementation error          ';
  maxaddr5 =
    'memory limit exceeded         ';
  maxblock5 =
    'block limit exceeded          ';
  maxbuf5 =
    'buffer limit exceeded         ';
  maxcase5 =
    'case limit exceeded           ';
  maxchan5 =
    'channel limit exceeded        ';
  maximport5 =
    'import limit exceeded         ';
  maxexport5 =
    'export limit exceeded         ';
  maxlabel5 =
    'branch limit exceeded         ';
  maxlevel5 =
    'nesting limit exceeded        ';
  maxstring5 =
    'string limit exceeded         ';
  maxdynamic5 =
    'dynamic fields limit exeeded  ';

  { file errors }

  name6 =
    'module name error             ';
  file6 =
    'file not found error          ';
  version6 =
    'module version error          ';

  { miscellaneous phrases }

  codeext =
    '.obj                          ';
  errorfile =
    'errors                        ';
  no =
    'no                            ';
  srcext =
    '.pas                          ';
  symext =
    '.sym                          ';
  yes =
    'yes                           ';

  { characters and ordinal values }

  apostrophe = '''' ; sp = ' '; dot = '.';
  etx = 3; del = 127; nl = 10;
  null = 0;


type

  { common types }

  operations = set of minoperation
    ..maxoperation;
  binary = file of integer;
  caserecord =
    record
      value, index: integer
    end;
  casetable =
    array [1..maxcase] of caserecord;
  phrase =
    packed array [1..maxphrase] of
      char;
  stringg =
    packed array [1..maxstring] of
      char;
  stringpointer = ^ stringg;
  identifier =
    packed array [1..maxident] of
      char;
  { a dual real is used to
    convert a real "a" to its
    binary representation by
    two integers "b" and "c"
    (or vice versa) }
  dualreal =
    record
      case split: boolean of
        false: (a: real);
        true: (b, c: integer)
    end;

  { a dual integer is used to
    convert an integer "a" to its
    binary representation by
    two charcaters "b" and "c"
    (or vice versa) }
  dualinteger = record
    case split: boolean of
      false: (a: integer);
      true: (b, c: char)
  end;

  { a dual string is used to
    convert a string pointer "a" to its
    binary representation by
    two integers "b" and "c"
    (or vice versa) }
 dualstring =
    record
      case split: boolean of
        false: (a: stringpointer);
        true: (b, c: integer)
    end;

{ compiler types and variables }

type
  table =
    array [1..maxbuf] of
      integer;
  buffer =
    record
      contents: table;
      length: integer
    end;

var
  correct, optimizing: boolean;
  lineno: integer;
  nulstring: stringg;
  modulename: identifier;
  nameless: identifier;
  noarguments, oneargument,
  twoarguments, threearguments,
  fourarguments, sixarguments,
  jumps, descriptions:
                operations;

{ initialization of operations }
procedure debugarguments(op, n: integer);

{ character routines }
procedure small(var ch: char);

{ phrase routines }
function phraselength(
  value: phrase): integer;
procedure writephrase(
  var outfile: text;
  value: phrase);
procedure readphrase(
  var value: phrase);
procedure makefilename(
  var name: identifier;
  ext: phrase;
  var filename: stringg);
procedure readboolean(
  var value: boolean);

{ stringg routines }
function stringlength(
  value: stringg): integer;
procedure writestring(
  var outfile: text;
  value: stringg;
  width: integer);
procedure readstring(
  var value: stringg);
procedure readident(
  var value: identifier);

{ compiler routines }
     { general compiler routines }
procedure error(kind: phrase);
procedure exitt;
procedure haltt(kind: phrase);
procedure newline(no: integer);
procedure accept(var ch: char);
procedure put(value: integer);
procedure get(
  var value: integer);
procedure getreal(
  var value: real);
procedure putreal(value: real);
procedure getstring(
  var length: integer;
  var value: stringg);
procedure putstring(
  length: integer;
  value: stringg);
{
procedure gettident(
  var name: identifier);
procedure putident(
  var id: identifier);
}
procedure getcase(
  var lineno, length: integer;
  var table: casetable);
procedure putcase(
  lineno, length: integer;
  table: casetable);
procedure getmoduledesc(
  var id: identifier;
  var key, lineno: integer);
procedure putmoduledesc(
  id: identifier;
  key, lineno: integer);
procedure savecode;
procedure rerun;
procedure firstpass;
procedure nextpass;  
procedure initcommon;

implementation

{ compiler variables }

var
  filename: stringg;
  errors, source: text;
  codef: binary;
  inpbuf, outbuf: buffer;
  endline, lineok: boolean;
  pass: integer;

procedure debugarguments(op, n: integer);
{EXCLUDE debugarguments AFTER DEBUGGING}
begin
  if (op in noarguments) and (n <> 0) or
     (op in oneargument) and (n <> 1) or
     (op in twoarguments) and (n <> 2) or
     (op in threearguments) and (n <> 3) or
     (op in fourarguments) and (n <> 4) or
     (op in sixarguments) and (n <> 6)
  then haltt(implementation5);
end;

{ character routines }

procedure small(var ch: char);
begin
  if (ch >= 'A') and (ch <= 'Z') then
    ch := chr(ord(ch) +
      ord('a') - ord('A'));
end;

{ phrase routines }

function phraselength(
  value: phrase): integer;
var i, j: integer;
begin
  i := 0; j := maxphrase;
  while i < j do
    if value[j] = sp
      then j := j - 1
      else i := j;
  phraselength := i
end;

procedure writephrase(
  var outfile: text;
  value: phrase);
begin
  write(outfile, value:
    phraselength(value))
end;

procedure readphrase(
  var value: phrase);
var ch: char; i: integer;
begin
  repeat
    while eoln do readln;
    read(ch)
  until ch <> sp;
  value[1] := ch;
  for i := 2 to maxphrase do
    if not eoln
      then read(value[i])
      else value[i] := sp;
  while not eoln do read(ch);
  readln
end;

procedure makefilename(
  var name: identifier;
  ext: phrase;
  var filename: stringg);
var i, j: integer; ch: char;
begin
  i := 1;
  ch := name[i];
  while ch <> chr(null) do begin
    filename[i] := ch;
    i := i + 1;
    ch := name[i];
  end;
  j := 1;
  ch := ext[j];
  while (ch <> sp)
    and (i < maxstring)
      and (j <= maxphrase) do
        begin
          filename[i] := ch;
          i := i + 1; j := j + 1;
          ch := ext[j]
        end;
  filename[i] := chr(null);
end;

procedure readboolean(
  var value: boolean);
var word: phrase;
begin
  readphrase(word);
  while (word <> yes)
    and (word <> no) do
      begin
        write(
          '      yes or no? ');
        readphrase(word)
      end;
  value := (word = yes)
end;

{ stringg routines }

function stringlength(
  value: stringg): integer;
var i, j: integer;
begin
  i := 0; j := maxstring;
  while i < j do
    if value[j] = chr(null)
      then j := j - 1
      else i := j;
  stringlength := i
end;

procedure writestring(
  var outfile: text;
  value: stringg;
  width: integer);
var i, n: integer;
begin
  n := stringlength(value);
  if width > n then
    for i := 1 to width - n do
      write(outfile, sp)
  else n := width;
  for i := 1 to n do
    write(outfile, value[i])
{AR: was  write(outfile, value:n) }
end;

procedure readstring(
  var value: stringg);
var ch: char; i: integer;
begin
  repeat
    while eoln do readln;
    read(ch)
  until ch <> sp;
  value[1] := ch;
  i := 2;
  while (i < maxstring) and not eoln do begin
    read(value[i]);
    i := i + 1
  end;
  value[i] := chr(null);
  while not eoln do read(ch);
  readln
end;

procedure readident(
  var value: identifier);
var ch: char; i, k: integer;
begin
  repeat
    while eoln do readln;
    read(ch)
  until ch <> sp;
  i := 1;
  small(ch);
  while ('a' <= ch) and (ch <= 'z') or
        ('0' <= ch) and (ch <= '9') do
    begin
      if i < maxident then begin
        value[i] := ch;
        i := i + 1
      end;
      if eoln then ch := sp else begin
        read(ch);
        small(ch)
      end;
    end;
  for k := i to maxident do value[k] := chr(null);
  while not eoln do read(ch);
  readln
end;

{ compiler routines }
     { general compiler routines }

procedure error(kind: phrase);
var n: integer;
begin
  if lineok then
    begin
      if correct then
        begin
          correct := false;
          writeln
        end;
      n := phraselength(kind);
      writeln(errors,
        'line ', lineno:4, sp,
        kind:n);
      writeln(
        'line ', lineno:4, sp,
        kind:n);
      lineok := false
    end
end;

procedure exitt;
begin
  if correct then
    writeln(errors,
      'no errors found')
  else writeln
end;

procedure haltt(kind: phrase);
var n: integer;
begin
  if correct then
    begin
      correct := false;
      writeln
    end;
  n := phraselength(kind);
  writeln(errors,
    'line ', lineno:4, sp,
    kind:n);
  writeln(
    'line ', lineno:4, sp,
    kind:n);
  {goto 1} exitt; halt;
end;

procedure newline(no: integer);
begin
  lineno := no;
  lineok := true
end;

procedure accept(var ch: char);
begin
  if eof(source) then
    begin
      lineno := lineno + 1;
      ch := chr(etx)
    end
  else
    begin
      if endline then
        begin
          lineno := lineno + 1;
          endline := false;
          lineok := true;
        end;
      if eoln(source) then
        begin
          readln(source);
          ch := chr(nl);
          endline := true;
        end
      else
          read(source, ch);
    end
end;

procedure put(value: integer);
begin
  if outbuf.length = maxbuf
    then haltt(maxbuf5);
  outbuf.length :=
    outbuf.length + 1;
  outbuf.contents[
    outbuf.length] := value
end;

procedure get(
  var value: integer);
begin
  inpbuf.length :=
    inpbuf.length + 1;
  value := inpbuf.contents[
    inpbuf.length];
end;

procedure getreal(
  var value: real);
var dual: dualreal;
begin
  dual.split := true;
  get(dual.b);
  get(dual.c);
  dual.split := false;
  value := dual.a
end;

procedure putreal(value: real);
var dual: dualreal;
begin
  dual.split := false;
  dual.a := value;
  dual.split := true;
  put(dual.b);
  put(dual.c)
end;

procedure getstring(
  var length: integer;
  var value: stringg);
var c, i: integer;
begin
  get(length);
  for i := 1 to length do
    begin
      get(c);
      value[i] := chr(c)
    end;
  for i := length + 1
    to maxstring do
      value[i] := chr(null)
end;

procedure putstring(
  length: integer;
  value: stringg);
var i: integer;
begin
  put(length);
  for i := 1 to length do
    put(ord(value[i]))
end;

procedure getcase(
  var lineno, length: integer;
  var table: casetable);
var i: integer;
begin
  get(lineno); get(length);
  for i := 1 to length do
    begin
      get(table[i].value);
      get(table[i].index)
    end
end;

procedure putcase(
  lineno, length: integer;
  table: casetable);
var i: integer;
begin
  put(lineno); put(length);
  for i := 1 to length do
    begin
      put(table[i].value);
      put(table[i].index)
    end
end;

procedure getmoduledesc(
  var id: identifier;
  var key, lineno: integer);
var i, j, k, c: integer;

  procedure gettident(var name: identifier);
    var i, k, c: integer;
  begin i := 1;
    repeat get(c); name[i] := chr(c); i := i + 1
    until c = null;
    for k := i to maxident do name[k] := chr(null);
  end;

begin
  gettident(id); get(key); get(lineno)
end;

procedure putmoduledesc(
  id: identifier;
  key, lineno: integer);
var i: integer;

  procedure putident(var id: identifier);
    var i, c: integer;
  begin i := 1;
    repeat c := ord(id[i]); put(c); i := i + 1
    until c = null
  end;

begin
  putident(id); put(key); put(lineno)
end;

procedure resetsource
  (var sourcef: text);
begin
  {$I-} reset(sourcef); {$I+}
  if (ioresult <> 0) then
    haltt(file6);
end;

procedure savecode;
var i: integer;
begin
  makefilename(modulename, codeext, filename);
  { nonstandard assign }
  assign(codef, filename);
  rewrite(codef);
  for i := 1 to outbuf.length do
    write(codef,
      outbuf.contents[i]);
{  export;}
end;

procedure rerun;
begin
  inpbuf.length := 0;
  outbuf.length := 0;
end;

procedure firstpass;

begin
  write('    module = ');
  readident(modulename);
  { nonstandard assign }
  assign(errors, errorfile);
  rewrite(errors);
  makefilename(modulename, srcext, filename);
  { nonstandard assign }
  assign(source, filename);
  resetsource(source);
  correct := true;
  lineno := 0; 
  writestring(errors,
    filename, maxstring-1);
  writeln(errors);
  writeln(errors);
  pass := 1;
  outbuf.length := 0;
  endline := true;
  lineno := 0;
end;

procedure nextpass;
begin
  pass := pass + 1;
  { swap buffers }
  inpbuf := outbuf;
  inpbuf.length := 0;
  outbuf.length := 0
end;

{ common initialization }
procedure initcommon;
var i: integer;

  procedure initoperations;
  begin
    noarguments :=
      [and2, endio2, endmethod2,
      endmodule2, eqord2, eqreal2,
      eqstring2, float2,
      floatleft2, for2, grord2,
      grreal2, grstring2, lsord2,
      lsreal2, lsstring2, neord2,
      nereal2, nestring2, ngord2,
      ngreal2, ngstring2, nlord2,
      nlreal2, nlstring2, not2,
      odd2, or2, parallel2,
      ordassign2, ordvalue2,
      realassign2, realvalue2,
      deref2, endinit2, dealloc2,
      len2, dassign2];
    oneargument :=
      [abs2, absint2, add2,
      addreal2, arctan2, assign2,
      assume2, checkio2, chr2,
      cos2, divide2, divreal2,
      do2, downto2, endall2,
      enddown2, endparallel2,
      endto2, eof2, eoln2,
      equal2, exp2, field2,
      goto2, ln2, minus2,
      minusreal2, modulo2, multiply2,
      multreal2, notequal2, open2,
      ordconst2, read2, readint2,
      readln2, readreal2, result2,
      round2, sin2, sqr2,
      sqrint2, sqrt2, subreal2,
      subtract2, to2, trunc2,
      value2, writeln2, defaddr2,
      globalcall2, globalvalue2,
      globalvar2, localreal2,
      localvalue2, localvar2,
      random2, moduleenter2,
      installm2, ixclass2,
      oxclass2, ifield2,
      iarray2, iclass2, alloc2,
      dvalue2, dresult2];

    twoarguments :=
      [endprocess2,
      pred2, mcall2, succ2,
      variable2, varparam2,
      xmcall2, xvariable2,
      write2, writebool2,
      writeint2, writestring2,
      defarg2, imcall2,
      valueparam2];
    threearguments :=
      [writereal2];
    fourarguments :=
      [index2, forall2, process2,
      receive2, send2, moduleinit2];
    sixarguments :=
      [method2];
    jumps :=
      [do2, downto2, enddown2,
      endto2, goto2, to2];
    descriptions := [modulehead2,
      loadshared2, loadprivate2];
  end; {initoperations }

  procedure testoperations;
  {REMOVE AFTER DEBUGGING}
    var all: operations;
      op: integer;
  begin
    all := [realconst2, stringconst2, case2] +
      noarguments + oneargument + twoarguments +
      threearguments + fourarguments +
      sixarguments + jumps + descriptions;
    for op := minoperation to maxoperation do
      if not(op in all) then
        haltt(implementation5);
  end; {testoperations}

begin {initcommon}
  optimizing := false;
  initoperations;
  testoperations;
  for i := 1 to maxstring do
    nulstring[i] := chr(null);
end;

end.