NOTE: Remove <brackets>, put those
words in italics.

Module =
    ModuleHeading
      [ "import" <Imported>ModuleList ";" ]
        DeclarationPart
          StatementPart "." . }
ModuleHeading =
    "module" <Module>Identifier
      [ "(" <Base>ModuleList ")" ] ";" . }
ModuleList =
    [ Identifier ":=" ] Identifier
      [ "," [ Identifier ":=" ] Identifier ] .
DeclarationPart =
    [ ConstantDefinitions ]
      [ TypeDefinitions ]
        [ VariableDeclarations ]
          MethodDeclarations .
ConstantDefinitions =
    "const" ConstantDefinition ";"
      [ ConstantDefinition ";" ]* .
ConstantDefinition =
    <Constant>Identifier
      [ ExportMark ]
        "=" Constant .
ExportMark = "*" .
Constant =
    [ Sign ] UnsignedConstant .
Sign =
    "+" | "-" .
UnsignedConstant =
    <Constant>QualIdent |
    UnsignedOrdinal |
    UnsignedReal |
    CharacterString .
QualIdent =
    [ ModuleIdentifier "." ]
      Identifier .
UnsignedOrdinal =
    CharacterConstant |
    UnsignedInteger .
CharacterConstant =
    "'" CharElement "'" .
CharElement =
    GraphicCharacter |
    ApostropheImmage .
ApostropheImmage =
    "''" .
UnsignedInteger =
    DigitSequence .
DigitSequence =
    Digit [ Digit ]* .
UnsignedReal =
    IntegerPart RealOption .
IntegerPart =
    DigitSequence .
RealOption =
    "." FractionalPart
      [ ScalingPart ] |
    ScalingPart .
FractionalPart =
    DigitSequence .
ScalingPart =
    Radix ScaleFactor .
Radix =
    "e" | "E" .
CharacterString =
    "'" StringElements "'" .
StringElements =
    CharElement
      [ CharElement ]* .
TypeDefinitions =
    "type" TypeDefinition ";"
      [ TypeDefinition ";" ]* .
TypeDefinition =
    <Type>Identifier [ ExportMark ]
      "=" NewType | ExistingType .
ExistingType =
     <Type>Identifier .
NewType =
    EnumeratedType |
    ArrayType |
    ClassType |
    ChannelType .
EnumeratedType =
    "(" NewConstantList ")" .
NewConstantList =
    <Constant>Identifier [ ","
      NewConstantList ] .
ArrayType =
    "array" IndexRange "of"
      <Type>QualIdent .
IndexRange =
    "[" <Ordinal>Constant ".."
      <Ordinal>Constant "]" .
ClassType =
    ".." |
    "class" FieldList "end" .
FieldList =
    ClassSection
      [ ";" ClassSection ]*
        [ ";" ] .
ClassSection =
    <Field>Identifier
      [ ExportMark ]
        SectionTail .
SectionTail =
    "," ClassSection |
    ":" <Type>QualIdent .
ChannelType =
    "*" "(" MessageTypeList ")" .
MessageTypeList =
    <MessageType>QualIdent [ ","
      <MessageType>QualIdent ]* .
VariableDeclarations =
    "var" VariableDeclaration ";"
      [ VariableDeclaration ";" ]* .
VariableDeclaration =
    <Variable>Identifier
      [ ExportMark ]
        VariableTail .
VariableTail =
    "," VariableDeclaration |
    ":" <Type>QualIdent .
MethodDeclarations =
    [ FunctionDeclaration ";" |
    ProcedureDeclaration ";" ]* .
FunctionDeclaration =
    FunctionHeading ";"
      <Method>Block .
FunctionHeading =
    "function" <Function>Identifier
      [ MethodMark ]
        FormalParameterPart ":"
          <Type>QualIdent .
FormalParameterPart =
    [ FormalParameterList ] .
FormalParameterList =
    "(" FormalParameters ")" .
FormalParameters =
    FormalParameterSection [ ";"
      FormalParameterSection ]* .
FormalParameterSection =
    [ "var" ]
      VariableDeclaration .
VariableDeclaration =
    <Variable>Identifier
      [ ExportMark ]
        VariableTail .
VariableTail =
    "," VariableDeclaration |
    ":" <Type>QualIdent .
ProcedureDeclaration =
    ProcedureHeading ";"
      <Method>Block .
ProcedureHeading =
    "procedure"
      <Procedure>Identifier
        [ MethodMark ]
          FormalParameterPart .
Block =
    DeclarationPart
      StatementPart .
StatementPart =
    CompoundStatement .
Expression =
    SimpleExpression
      [ RelationalOperator
        SimpleExpression ] .
RelationalOperator =
    "<" | "=" | ">" |
    "<=" | "<>" | ">=" .
SimpleExpression =
    [ Sign ] Term
       [ AddingOperator Term ]* .
AddingOperator =
    "+" | "-" | "or" .
Term =
    Factor [ MultiplyingOperator
      Factor ]* .
MultiplyingOperator =
    "*" | "/" | "div" | "mod" |
    "and" .
Factor =
    UnsignedConstant |
    QualifiedVariableAccess |
    FunctionDesignator |
    "(" Expression ")" |
    "not" Factor .
QualifiedVariableAccess =
    QualIdent
      [ ComponentSelector ] * .
ComponentSelector =
    IndexedSelector |
    FieldSelector .
IndexedSelector =
    "[" IndexExpressions "]" .
IndexExpressions =
    IndexExpression
      [ "," IndexExpression ]* .
IndexExpression =
    Expression .
FieldSelector =
    "." <Field>Identifier .
FunctionDesignator =
    FunctionIdent
      ActualParameterPart |
    StandardFunctionDesignator .
FunctionIdent =
    OverloadedIdent | QualIdent .
OverloadedIdent =
    " ^ " Identifier .
ActualParameterPart =
    [ ActualParameterList ] .
ActualParameterList =
    "(" ActualParameters ")" .
ActualParameters =
    [ ActualParameters "," ]
      ActualParameter .
ActualParameter =
    Expression |
    VariableAccess .
VariableAccess =
    EntireVariableAccess
      [ ComponentSelector ]* .
EntireVariableAccess =
    <Variable>Identifier .
StandardFunctionDesignator =
    FileFunctionDesignator |
    MathFunctionDesignator .
FileFunctionDesignator =
    "eof" | "eoln" .
MathFunctionDesignator =
    MathFunctionIdentifier
      "(" Expression ")" .
MathFunctionIdentifier =
    "abs" | "arctan" | "chr" |
    "cos" | "exp" | "ln" |
    "odd" | "ord" | "pred" |
    "round" | "sin" | "sqr" |
    "sqrt" | "succ" | "trunc"
    "random".
Statement =
    EmptyStatement |
    AssignmentStatement |
    ProcedureStatement |
    ExternalProcedureStatement |
    IfStatement |
    WhileStatement |
    RepeatStatement |
    ForStatement |
    CaseStatement |
    CompoundStatement |
    ParallelStatement |
    ForallStatement |
    UnrestrictedStatement |
    AssumeStatement .
EmptyStatement = .
AssignmentStatement =
    LeftPart ":=" Expression .
LeftPart =
    FunctionVariable |
    VariableAccess .
FunctionVariable =
    <Function>Identifier .
ProcedureStatement =
    <Procedure>Identifier
      ActualParameterPart |
    StandardProcedureStatement .
StandardProcedureStatement =
    ReadStatement |
    WriteStatement |
    OpenStatement |
    ReceiveStatement |
    SendStatement .
ReadStatement =
    "read" ReadParameterList |
    "readln"
       [ ReadParameterList ] .
ReadParameterList =
    "(" ReadParameters ")" .
ReadParameters =
    ReadParameter
      [ "," ReadParameter ]* .
ReadParameter =
    VariableAccess .
WriteStatement =
    "write" WriteParameterList |
    "writeln"
      [ WriteParameterList ] .
WriteParameterList =
    "(" WriteParameters ")" .
WriteParameters =
    WriteParameter
      [ "," WriteParameter ]* .
WriteParameter =
    Expression WriteOption
      WriteOption .
WriteOption =
    [ ":" Expression ] .
OpenStatement =
    "open" "("
      OpenParameters ")" .
OpenParameters =
    OpenParameter [ ","
      OpenParameter ]* .
OpenParameter =
    <Channel>VariableAccess .
ReceiveStatement =
    "receive" "("
      ReceiveParameters ")" .
ReceiveParameters =
    <Channel>Expression ","
      InputVariableList .
InputVariableList =
    <Input>VariableAccess
      [ ","
        <Input>VariableAccess ]* .
SendStatement =
    "send" "("
      SendParameters ")" .
SendParameters =
    <Channel>Expression ","
      OutputExpressionList .
OutputExpressionList =
    <Output>Expression [ ","
      <Output>Expression ]* .
ExternalProcedureStatement =
    ExternalIdent
      ActualParameterPart .
ExternalIdent =
    OverloadedIdent | QualIdent .
IfStatement =
    "if" Expression
      "then" Statement
        [ "else" Statement ] .
WhileStatement =
    "while" Expression
      "do" Statement .
RepeatStatement =
    "repeat" StatementSequence
      "until" Expression .
StatementSequence =
    Statement
      [ ";" Statement ]* . 
ForStatement =
    ForClause ForOption .
ForOption =
    UpClause | DownClause . 
UpClause =
    "to" Expression
      "do" Statement . 
DownClause =
    "downto" Expression
      "do" Statement .
CaseStatement =
    "case" Expression "of"
      CaseList "end" .
CaseList =
    CaseListElement
      [ ";" CaseListElement ]* .
        [ ";" ] .
CaseListElement =
    CaseConstantList
      ":" Statement .
CaseConstantList =
    CaseConstant
      [ "," CaseConstant ]* .
CaseConstant =
    <Ordinal>Constant .
CompoundStatement =
    "begin" StatementSequence
       "end" .
ParallelStatement =
    "parallel"
      ProcessStatementList
        "end" .
ProcessStatementList =
    ProcessStatement
      [ "|" ProcessStatement ]* .
ProcessStatement =
    StatementSequence . 
ForallStatement =
    "forall"
      IndexVariableDeclaration
        "do" Statement .
IndexVariableDeclaration =
    <Variable>Identifier ":="
      ProcessIndexRange .
ProcessIndexRange =
    Expression "to"
      Expression .
UnrestrictedStatement =
    SicClause Statement .
SicClause =
    "[" "sic" "]" .
AssumeStatement =
    "assume" Expression .
